#!/usr/bin/perl
use File::stat;

$print0 = 0;

if ($ARGV[0] eq "--help"){
  print <<"HERE";

pkg-examine -- print package contents.

usage:
    pkg-examine -0 <package>

Prints the files which belong to the package user 
<package>.

If the -0 option is given, prints all files belonging 
to <package> separated by null characters, as in the 
"-print0" option of find.

Written by Robert McIntyre. This software is free
software and is released to the public domain.
  
HERE
exit 0;
}

$" = " ";

if ($ARGV[0] eq "-0"){
    $print0 = 1;
    $pkg_name = $ARGV[1];
}
else {
    $pkg_name = $ARGV[0];
}




`id -g $pkg_name 2>/dev/null`;
if (($pkg_name eq "") || $?){
    print "No group named $pkg_name.\n";
    exit 0;
}

$file_str = `find /usr /opt /etc -group $pkg_name -print0`;
if ($print0){
    print $file_str;
    exit 0;
}

@files = split(/\0/, $file_str);


print "All files owned by this package:\n";
foreach (@files){print "   $_\n";}

print "SetUID/SetGID files:\n";
foreach $file(@files){

    $sb = stat($file);
    $mode = $sb->mode & 07777;
    if ($mode & 07000){
	printf "%s, %04o\n", $file, $mode;
    }
}

    



